package com.fzm.portal;

import cn.fzm.chain.simplesdk.client.ParaChainClient;
import cn.hutool.crypto.SecureUtil;
import cn.hutool.json.JSON;
import cn.hutool.json.JSONUtil;
import com.fzm.common.constant.RedisConstant;
import com.fzm.common.entity.CopyrightAuthorityRelation;
import com.fzm.common.entity.OpusCategory;
import com.fzm.common.entity.dto.CopyrightRequest;
import com.fzm.common.entity.vo.CopyrightVo;
import com.fzm.common.enums.ResultCode;
import com.fzm.common.exception.GlobalException;
import com.fzm.common.properties.CopyrightProperties;
import com.fzm.common.service.CopyrightApplyService;
import com.fzm.common.service.CopyrightAuthorityRelationService;
import com.fzm.common.service.OpusCategoryService;
import com.fzm.common.service.impl.CopyrightAuthorityRelationServiceImpl;
import com.fzm.common.utils.JsonUtil;
import com.fzm.common.utils.RedisUtil;
import org.junit.jupiter.api.Test;
import org.redisson.Redisson;
import org.redisson.api.RSemaphore;
import org.redisson.api.RedissonClient;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.security.crypto.password.PasswordEncoder;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.Map;
import java.util.TreeMap;
import java.util.concurrent.ExecutionException;

@SpringBootTest
class LyPortalApplicationTests {

    @Resource
    private RedisUtil redisUtil;

    @Resource
    private PasswordEncoder passwordEncoder;

    @Resource
    StringRedisTemplate stringRedisTemplate;

    @Resource
    ParaChainClient paraClient;

    @Resource
    RedissonClient redisson;

    @Resource
    private CopyrightApplyService copyrightApplyService;

    @Resource
    private OpusCategoryService opusCategoryService;

    @Resource
    private CopyrightProperties copyrightProperties;

    @Test
    void test1() throws ExecutionException, InterruptedException {
//        CopyrightVo detail = copyrightApplyService.getDetail(48);
//        OpusCategory opusCategory = opusCategoryService.getById(1);
//        CopyrightRequest copyrightRequest = new CopyrightRequest(detail, opusCategory);
//        TreeMap<String, String> map = new TreeMap<>();
//        map.put("app_id", "289391457858");
//        map.put("app_secret", "xExjKUCYH1nrze6Hpxf8s1dYWdxEggo2FiwKlZKygCItOV7E8bFhkyr4C192uhK");
//        map.put("biz_content", JSONUtil.toJsonStr(copyrightRequest.getBiz_content()));
//        map.put("charset", copyrightRequest.getCharset());
//        map.put("sign_type", copyrightRequest.getSign_type());
//        map.put("timestamp", copyrightRequest.getTimestamp());
//        map.put("version", copyrightRequest.getVersion());
//        StringBuilder sb = new StringBuilder();
//        for (Map.Entry<String, String> entry : map.entrySet()) {
//            String key = entry.getKey();
//            String value = entry.getValue();
//            sb.append(key).append("=").append(value).append("&");
//        }
//        String signStr = sb.deleteCharAt(sb.length() - 1).toString();
//        System.out.println(signStr);
//        System.out.println(SecureUtil.md5(signStr));
//        System.out.println(JSONUtil.toJsonStr(copyrightRequest));
    }

    @Test
    void contextLoads() {
        System.out.println("redisson = " + redisson);
        RSemaphore semaphore = redisson.getSemaphore("banner09");
        boolean b = semaphore.trySetPermits(10);
        for (int i = 0; i < 3; i++) {
            boolean acquire = semaphore.tryAcquire();
            if (!acquire) {
                throw GlobalException.newException(ResultCode.VALIDATE_FAILED);
            }
            //System.out.println("semaphore.drainPermits() = " + semaphore.drainPermits());
            System.out.println("semaphore.availablePermits() = " + semaphore.availablePermits());
        }

    }

}
